Package net.sf.saxon.functions

## Class CallableFunction

- java.lang.Object
- - net.sf.saxon.functions.AbstractFunction
  - - net.sf.saxon.functions.CallableFunction

- All Implemented Interfaces:
    `Callable`, `Function`, `GroundedValue`, `Item`, `Sequence`

      public class CallableFunction
      extends AbstractFunction

  A function item that wraps a Callable

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CallableFunction​(int arity, Callable callable, FunctionItemType type)` |
    `CallableFunction​(SymbolicName.F name, Callable callable, FunctionItemType type)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Sequence` | `call​(XPathContext context, Sequence[] args)` | Invoke the function
    `void` | `export​(ExpressionPresenter out)` | Output information about this function item to the diagnostic explain() output
    `AnnotationList` | `getAnnotations()` | Get the function annotations (as defined in XQuery).
    `int` | `getArity()` | Get the arity of the function
    `Callable` | `getCallable()` |
    `java.lang.String` | `getDescription()` | Get a description of this function for use in error messages.
    `FunctionItemType` | `getFunctionItemType()` | Get the item type of the function item
    `StructuredQName` | `getFunctionName()` | Get the name of the function, or null if it is anonymous
    `void` | `setAnnotations​(AnnotationList annotations)` |
    `void` | `setCallable​(Callable callable)` |
    `void` | `setType​(FunctionItemType type)` |

    - ### Methods inherited from class net.sf.saxon.functions.AbstractFunction

      `atomize, deepEquals, effectiveBooleanValue, getOperandRoles, getStringValue, getStringValueCS, isArray, isMap, isTrustedResultType, makeNewContext, simplify, typeCheck`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.Function

      `getGenre, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, isStreamed, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### CallableFunction

          public CallableFunction​(SymbolicName.F name,
                                  Callable callable,
                                  FunctionItemType type)

    - #### CallableFunction

          public CallableFunction​(int arity,
                                  Callable callable,
                                  FunctionItemType type)

  - ### Method Detail

    - #### getCallable

          public Callable getCallable()

    - #### setCallable

          public void setCallable​(Callable callable)

    - #### setType

          public void setType​(FunctionItemType type)

    - #### getFunctionItemType

          public FunctionItemType getFunctionItemType()

      Get the item type of the function item
      Returns:
        the function item's type

    - #### getFunctionName

          public StructuredQName getFunctionName()

      Get the name of the function, or null if it is anonymous
      Returns:
        the function name, or null for an anonymous inline function

    - #### getDescription

          public java.lang.String getDescription()

      Get a description of this function for use in error messages. For named functions, the description is the function name (as a lexical QName). For others, it might be, for example, "inline function", or "partially-applied ends-with function".
      Returns:
        a description of the function for use in error messages

    - #### getArity

          public int getArity()

      Get the arity of the function
      Returns:
        the number of arguments in the function signature

    - #### setAnnotations

          public void setAnnotations​(AnnotationList annotations)

    - #### getAnnotations

          public AnnotationList getAnnotations()

      Description copied from interface: `Function`
      Get the function annotations (as defined in XQuery). Returns an empty list if there are no function annotations.
      Specified by:
        `getAnnotations` in interface `Function`
      Overrides:
        `getAnnotations` in class `AbstractFunction`
      Returns:
        the function annotations

    - #### call

          public Sequence call​(XPathContext context,
                               Sequence[] args)
                        throws XPathException

      Invoke the function
      Parameters:
        `context` - the XPath dynamic evaluation context
        `args` - the actual arguments to be supplied
      Returns:
        the result of invoking the function
      Throws:
        `XPathException` - if a dynamic error occurs within the function

    - #### export

          public void export​(ExpressionPresenter out)

      Output information about this function item to the diagnostic explain() output
      Specified by:
        `export` in interface `Function`
      Overrides:
        `export` in class `AbstractFunction`
      Parameters:
        `out` - the destination for the output